'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _humps = require('humps');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function deserializeRelationships() {
  var resources = arguments.length <= 0 || arguments[0] === undefined ? [] : arguments[0];
  var store = arguments[1];

  return resources.map(function (resource) {
    return deserializeRelationship(resource, store);
  }).filter(function (resource) {
    return !!resource;
  });
}

function deserializeRelationship() {
  var resource = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
  var store = arguments[1];

  if (!resource || !store[(0, _humps.camelize)(resource.type)] || !store[(0, _humps.camelize)(resource.type)][resource.id]) return null;
  return deserialize(store[(0, _humps.camelize)(resource.type)][resource.id], store);
}

function deserialize(_ref, store) {
  var id = _ref.id;
  var type = _ref.type;
  var attributes = _ref.attributes;
  var relationships = _ref.relationships;
  var meta = _ref.meta;

  var resource = {};

  if (id) resource = _extends({}, resource, { id: id });
  resource = _extends({}, resource, { _type: type });

  if (attributes) {
    resource = Object.keys(attributes).reduce(function (resource, key) {
      return _extends({}, resource, _defineProperty({}, (0, _humps.camelize)(key), attributes[key]));
    }, resource);
  }

  if (relationships) {
    resource = Object.keys(relationships).reduce(function (resource, key) {
      return _extends({}, resource, _defineProperty({}, (0, _humps.camelize)(key), function () {
        if (Array.isArray(relationships[key].data)) {
          return deserializeRelationships(relationships[key].data, store);
        } else {
          return deserializeRelationship(relationships[key].data, store);
        }
      }));
    }, resource);
  }

  if (meta) {
    resource._meta = meta;
  }

  return resource;
}

exports.default = deserialize;