'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.receive = exports.del = exports.patch = exports.put = exports.post = exports.get = exports.DELETE = exports.PATCH = exports.PUT = exports.POST = exports.GET = exports.RECEIVE = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _humps = require('humps');

var _serialize = require('../serialize');

var _serialize2 = _interopRequireDefault(_serialize);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var RECEIVE = exports.RECEIVE = '@@redux-jsonapi/RECEIVE';
var GET = exports.GET = '@@redux-jsonapi/GET';
var POST = exports.POST = '@@redux-jsonapi/POST';
var PUT = exports.PUT = '@@redux-jsonapi/PUT';
var PATCH = exports.PATCH = '@@redux-jsonapi/PATCH';
var DELETE = exports.DELETE = '@@redux-jsonapi/DELETE';

var request = function request(method) {
  var payload = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];
  var meta = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

  return {
    type: method,
    payload: payload,
    meta: meta
  };
};

var get = exports.get = function get(resource) {
  var _ref = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  var meta = _ref.meta;

  var payload = _objectWithoutProperties(_ref, ['meta']);

  return request(GET, _extends({}, payload, { resource: (0, _serialize2.default)(resource) }), meta);
};

var post = exports.post = function post(resource) {
  var _ref2 = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  var meta = _ref2.meta;

  var payload = _objectWithoutProperties(_ref2, ['meta']);

  return request(POST, _extends({}, payload, { resource: (0, _serialize2.default)(resource) }), meta);
};

var put = exports.put = function put(resource) {
  var _ref3 = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  var meta = _ref3.meta;

  var payload = _objectWithoutProperties(_ref3, ['meta']);

  return request(PUT, _extends({}, payload, { resource: (0, _serialize2.default)(resource) }), meta);
};

var patch = exports.patch = function patch(resource) {
  var _ref4 = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  var meta = _ref4.meta;

  var payload = _objectWithoutProperties(_ref4, ['meta']);

  return request(PATCH, _extends({}, payload, { resource: (0, _serialize2.default)(resource) }), meta);
};

var del = exports.del = function del(resource) {
  var _ref5 = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  var meta = _ref5.meta;

  var payload = _objectWithoutProperties(_ref5, ['meta']);

  return request(DELETE, _extends({}, payload, { resource: (0, _serialize2.default)(resource) }), meta);
};

var receive = exports.receive = function receive(resources) {
  return {
    type: RECEIVE,
    payload: {
      resources: resources
    }
  };
};

function getInitialState() {
  return {};
}

function receiveReducer(state, _ref6) {
  var resources = _ref6.resources;

  return resources.reduce(function (nextState, resource) {
    return _extends({}, nextState, _defineProperty({}, (0, _humps.camelize)(resource.type), _extends({}, nextState[(0, _humps.camelize)(resource.type)], _defineProperty({}, resource.id, resource))));
  }, state);
}

function reducer() {
  var state = arguments.length <= 0 || arguments[0] === undefined ? getInitialState() : arguments[0];
  var _ref7 = arguments[1];
  var type = _ref7.type;
  var payload = _ref7.payload;

  switch (type) {
    case RECEIVE:
      return receiveReducer(state, payload);
    default:
      return state;
  }
}

exports.default = reducer;