'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _humps = require('humps');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function serializeRelationships() {
  var resources = arguments.length <= 0 || arguments[0] === undefined ? [] : arguments[0];

  return resources.map(function (resource) {
    return serializeRelationship(resource);
  });
}

function serializeRelationship() {
  var _ref = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  var id = _ref.id;
  var _type = _ref._type;

  return { id: id, type: _type };
}

function serialize(_ref2) {
  var id = _ref2.id;
  var _type = _ref2._type;
  var _meta = _ref2._meta;

  var otherAttributes = _objectWithoutProperties(_ref2, ['id', '_type', '_meta']);

  var resource = {};

  if (id) resource = _extends({}, resource, { id: id });
  resource = _extends({}, resource, { type: _type });

  resource = Object.keys(otherAttributes).reduce(function (resource, key) {
    if (typeof otherAttributes[key] === 'function') {
      var data = otherAttributes[key].call();

      if (Array.isArray(data)) {
        return _extends({}, resource, {
          relationships: _extends({}, resource.relationships, _defineProperty({}, (0, _humps.decamelize)(key), {
            data: serializeRelationships(data)
          }))
        });
      }

      return _extends({}, resource, {
        relationships: _extends({}, resource.relationships, _defineProperty({}, (0, _humps.decamelize)(key), {
          data: data && serializeRelationship(data)
        }))
      });
    }

    return _extends({}, resource, {
      attributes: _extends({}, resource.attributes, _defineProperty({}, (0, _humps.decamelize)(key), otherAttributes[key]))
    });
  }, resource);

  if (_meta) resource = _extends({}, resource, { meta: _meta });

  return resource;
}

exports.default = serialize;